<script setup lang="ts">
import { computed, onMounted, reactive } from "vue";
import type {
  OwnershipTransferRequestOut,
  WorkflowOut,
  WorkflowVersionOut,
} from "@/client/types.gen";
import {
  NextflowVersion,
  OwnershipTypeEnum,
  WorkflowVersionStatus,
} from "@/client/types.gen";
import WorkflowWithVersionsCard from "@/components/workflows/WorkflowWithVersionsCard.vue";
import CreateWorkflowModal from "@/components/workflows/modals/CreateWorkflowModal.vue";
import CardTransitionGroup from "@/components/transitions/CardTransitionGroup.vue";
import UpdateWorkflowModal from "@/components/workflows/modals/UpdateWorkflowModal.vue";
import UpdateWorkflowVersionIconModal from "@/components/workflows/modals/UpdateWorkflowVersionIconModal.vue";
import UpdateWorkflowCredentialsModal from "@/components/workflows/modals/UpdateWorkflowCredentialsModal.vue";
import { useWorkflowStore } from "@/stores/workflows";
import { useWorkflowExecutionStore } from "@/stores/workflowExecutions";
import { environment } from "@/environment";
import ArbitraryWorkflowModal from "@/components/workflows/modals/ArbitraryWorkflowModal.vue";
import OtrModal from "@/components/modals/ShowOtrModal.vue";
import ListOtrsModal from "@/components/modals/ListOtrsModal.vue";
import { useOTRStore } from "@/stores/otrs";
import { useUserStore } from "@/stores/users";
import { Modal, Tooltip } from "bootstrap";
import { useSettingsStore } from "@/stores/settings";
import CreateOtrModal from "@/components/modals/CreateOtrModal.vue";
import DeleteWorkflowModal from "@/components/workflows/modals/DeleteWorkflowModal.vue";

const workflowRepository = useWorkflowStore();
const workflowExecutionRepository = useWorkflowExecutionStore();
const otrRepository = useOTRStore();
const userRepository = useUserStore();
const settingsStore = useSettingsStore();

let showOtrModalInstance: Modal | null = null;
let createOtrModalInstance: Modal | null = null;

const workflowsState = reactive<{
  loading: boolean;
  updateWorkflow: WorkflowOut;
  potentialWorkflowDelete?: WorkflowOut;
  updateIconVersion: WorkflowVersionOut;
  showOtrTarget: string;
  createOtrTarget: WorkflowOut;
}>({
  loading: true,
  potentialWorkflowDelete: undefined,
  showOtrTarget: "",
  createOtrTarget: {
    short_description: "",
    name: "",
    versions: [],
    repository_url: "",
    workflow_id: "",
    developer_id: "",
    private: false,
  },
  updateWorkflow: {
    short_description: "",
    name: "",
    versions: [
      {
        version: "1.0.0",
        created_at: 0,
        workflow_version_id: "",
        status: WorkflowVersionStatus.CREATED,
        workflow_id: "",
        icon_url: "",
        modes: [],
        nextflow_version: NextflowVersion["24_04_2"],
      },
    ],
    repository_url: "",
    workflow_id: "",
    developer_id: "",
    private: false,
  },
  updateIconVersion: {
    version: "",
    workflow_id: "",
    workflow_version_id: "",
    modes: [],
    icon_url: null,
    created_at: 0,
    status: WorkflowVersionStatus.CREATED,
    nextflow_version: NextflowVersion["24_04_2"],
  },
});

const sortedWorkflows = computed<WorkflowOut[]>(() => {
  const temp = [...workflowRepository.ownWorkflows];
  temp.sort((a, b) => (a.name.toLowerCase() > b.name.toLowerCase() ? 1 : -1));
  return temp;
});

const otrForNewWorkflows = computed<OwnershipTransferRequestOut[]>(() =>
  otrRepository.workflowOtrs.filter(
    (otr) => otr.new_owner_uid === userRepository.currentUID,
  ),
);

function workflowUpdateClicked(workflow: WorkflowOut) {
  workflowsState.updateWorkflow = workflow;
}

function iconUpdateClicked(version: WorkflowVersionOut) {
  workflowsState.updateIconVersion = version;
}

function workflowDeleteClicked(workflow: WorkflowOut) {
  workflowsState.potentialWorkflowDelete = workflow;
}

function confirmedWorkflowDelete(workflow_id?: string) {
  if (workflow_id) {
    workflowRepository.deleteWorkflow(workflow_id).finally(() => {
      workflowsState.potentialWorkflowDelete = undefined;
    });
  }
}

function updateIconClicked(version: WorkflowVersionOut) {
  workflowsState.updateIconVersion = version;
}

function showOtrModal(workflowId: string) {
  workflowsState.showOtrTarget = workflowId;
  showOtrModalInstance?.show();
}

function showCreateOtrModal(workflow: WorkflowOut) {
  workflowsState.createOtrTarget = workflow;
  createOtrModalInstance?.show();
}

onMounted(() => {
  showOtrModalInstance = Modal.getOrCreateInstance("#view-workflow-otr-modal");
  createOtrModalInstance = Modal.getOrCreateInstance(
    "#create-workflow-otr-modal",
  );
  workflowRepository.fetchOwnWorkflows(() => {
    workflowsState.loading = false;
  });
  otrRepository.fetchOwnOtrs(OwnershipTypeEnum.WORKFLOW);
  workflowExecutionRepository.fetchExecutionsForDevStatistics();
  new Tooltip("#showWorkflowOtrsButtons");
});
</script>

<template>
  <otr-modal
    :otr-target-id="workflowsState.showOtrTarget"
    modal-id="view-workflow-otr-modal"
  />
  <list-otrs-modal
    :otrs="otrForNewWorkflows"
    :otr-type="OwnershipTypeEnum.WORKFLOW"
    modal-id="list-workflow-otrs-modal"
  />
  <create-otr-modal
    modal-id="create-workflow-otr-modal"
    :target="workflowsState.createOtrTarget"
  />
  <create-workflow-modal modal-id="createWorkflowModal" />
  <update-workflow-modal
    :workflow="workflowsState.updateWorkflow"
    modal-id="updateWorkflowModal"
  />
  <delete-workflow-modal
    modal-id="deleteWorkflowModal"
    :workflow="workflowsState.potentialWorkflowDelete"
    @confirm-delete="confirmedWorkflowDelete"
  />
  <update-workflow-version-icon-modal
    modal-id="updateWorkflowVersionIconModal"
    :workflow-name="
      workflowRepository.comprehensiveWorkflowMapping[
        workflowsState.updateIconVersion.workflow_id
      ]?.name
    "
    :version="workflowsState.updateIconVersion"
  />
  <update-workflow-credentials-modal
    :workflow="workflowsState.updateWorkflow"
    modal-id="updateWorkflowCredentialsModal"
  />
  <div
    class="row border-bottom mb-4 justify-content-between align-items-center pb-2 pe-2"
  >
    <h2 class="w-fit">My Workflows</h2>
    <div class="w-fit">
      <button
        id="showWorkflowOtrsButtons"
        :hidden="otrForNewWorkflows.length === 0"
        class="btn border btn-lg shadow-sm position-relative me-3"
        :class="{
          'btn-light': settingsStore.lightThemeActive,
          'btn-secondary': settingsStore.darkThemeActive,
        }"
        data-bs-title="Ownership transfer requests"
        data-bs-target="#list-workflow-otrs-modal"
        data-bs-toggle="modal"
      >
        Requests
        <span
          class="position-absolute top-0 start-100 translate-middle badge rounded-pill bg-danger"
          style="font-size: 0.8em"
        >
          {{ otrForNewWorkflows.length }}
          <span class="visually-hidden"
            >open workflow ownership transfer requests</span
          >
        </span>
      </button>
      <button
        class="btn btn-lg btn-primary w-fit"
        data-bs-toggle="modal"
        data-bs-target="#createWorkflowModal"
      >
        Create
      </button>
    </div>
  </div>
  <div v-if="environment.DEV_SYSTEM" class="d-grid gap-2 col-4 mx-auto">
    <button
      class="btn btn-success btn-lg fs-3"
      role="button"
      data-bs-toggle="modal"
      data-bs-target="#arbitraryWorkflowModal"
    >
      Test my Workflow
    </button>
    <arbitrary-workflow-modal modal-id="arbitraryWorkflowModal" />
  </div>
  <div v-if="!workflowsState.loading">
    <card-transition-group
      v-if="sortedWorkflows.length > 0"
      class="d-flex flex-wrap align-items-center justify-content-between mt-5"
    >
      <workflow-with-versions-card
        v-for="workflow in sortedWorkflows"
        :key="workflow.workflow_id"
        :workflow="workflow"
        :loading="false"
        @workflow-update-click="workflowUpdateClicked"
        @workflow-update-credentials-click="workflowUpdateClicked"
        @workflow-delete-click="workflowDeleteClicked"
        @workflow-update-icon-click="iconUpdateClicked"
        @create-otr-click="showCreateOtrModal"
        @show-otr-click="showOtrModal"
      />
    </card-transition-group>
    <div v-else class="text-center mt-5 fs-2">
      There are currently no workflows that you created.<br />
      <a href="#" data-bs-toggle="modal" data-bs-target="#createWorkflowModal"
        >Create a new one</a
      >
    </div>
  </div>
  <div
    v-else
    class="d-flex flex-wrap align-items-center justify-content-between mt-5"
  >
    <workflow-with-versions-card
      v-for="n in 4"
      :key="n"
      :workflow="{
        workflow_id: '',
        versions: [],
        name: '',
        repository_url: '',
        short_description: '',
        developer_id: '',
        private: false,
      }"
      loading
      @workflow-update-icon-click="updateIconClicked"
    />
  </div>
</template>
<style scoped></style>
